/*! \file rename.c \brief Rename-Function */
//###########################################################
///	\ingroup singlefat
///	\code #include "dos.h" \endcode
///	\par Uebersicht
//###########################################################
// Benutzung auf eigene Gefahr !
//
// Use at your own risk !
//
//#########################################################################
// Compiler: avr-gcc 3.4.5
//#########################################################################
//@{
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dos.h"

//dos.c
#ifdef DOS_WRITE
 #ifdef DOS_RENAME
 
//###########################################################
// rename a file  - added by beta-frank - 23.04.07
/*!\brief Rename a file
 * \param		OldName	DOS 8.3 name of the file 
 * \param		NewName	DOS 8.3 name of the file 
 * \return 		F_OK if file could be renamed, F_ERROR if not
 */
U8 Rename(char *OldName, char *NewName)
//###########################################################
{
   if(FileFlag!=0) return F_ERROR; // don't rename if a file is open
  
   Remove(NewName); // its better to do this first !
   
   FileAttr=0xFF; // test if we really find a file and not a directory
   // FileAttr then must be ATTR_FILE
  
   if(FindName(OldName)==FULL_MATCH) // Look if file exists
   {
      if(FileAttr!=ATTR_FILE) return F_ERROR; // this was not a file !
 
      Fopen(OldName,F_READ);  //To fill some usefull variables...
      MakeFileName(NewName,FileName,FileExt); //Split into name and extension
      UpdateFileEntry();
      Fclose();
   }
   return F_OK; 
}
 #endif
#endif